/*
 * Copyright 2004-2009 Luc Verhaegen.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */
#ifndef HAVE_VIA_REGS_H
#define HAVE_VIA_REGS_H

CARD8 VGASRReadI(int scrnIndex, CARD8 index);
void VGASRWriteI(int scrnIndex, CARD8 index, CARD8 data);
void VGASRMaskI(int scrnIndex, CARD8 index, CARD8 data, CARD8 mask);
#define VGASRRead(p, index) VGASRReadI((p)->scrnIndex, (index))
#define VGASRWrite(p, index, data) VGASRWriteI((p)->scrnIndex, (index), (data))
#define VGASRMask(p, index, data, mask) VGASRMaskI((p)->scrnIndex, (index), (data), (mask))

CARD8 VGACRReadI(int scrnIndex, CARD8 index);
void VGACRWriteI(int scrnIndex, CARD8 index, CARD8 data);
void VGACRMaskI(int scrnIndex, CARD8 index, CARD8 data, CARD8 mask);
#define VGACRRead(p, index) VGACRReadI((p)->scrnIndex, (index))
#define VGACRWrite(p, index, data) VGACRWriteI((p)->scrnIndex, (index), (data))
#define VGACRMask(p, index, data, mask) VGACRMaskI((p)->scrnIndex, (index), (data), (mask))

CARD8 VGAGRReadI(int scrnIndex, CARD8 index);
void VGAGRWriteI(int scrnIndex, CARD8 index, CARD8 data);
void VGAGRMaskI(int scrnIndex, CARD8 index, CARD8 data, CARD8 mask);
#define VGAGRRead(p, index) VGAGRReadI((p)->scrnIndex, (index))
#define VGAGRWrite(p, index, data) VGAGRWriteI((p)->scrnIndex, (index), (data))
#define VGAGRMask(p, index, data, mask) VGAGRMaskI((p)->scrnIndex, (index), (data), (mask))

CARD8 VGAEnableReadI(int scrnIndex);
void VGAEnableWriteI(int scrnIndex, CARD8 data);
void VGAEnableMaskI(int scrnIndex, CARD8 data, CARD8 mask);
#define VGAEnableRead(p) VGAEnableReadI((p)->scrnIndex)
#define VGAEnableWrite(p, data) VGAEnableWriteI((p)->scrnIndex, (data))
#define VGAEnableMask(p, data, mask) VGAEnableMaskI((p)->scrnIndex, (data), (mask))

CARD8 VGAMiscReadI(int scrnIndex);
void VGAMiscWriteI(int scrnIndex, CARD8 data);
void VGAMiscMaskI(int scrnIndex, CARD8 data, CARD8 mask);
#define VGAMiscRead(p) VGAMiscReadI((p)->scrnIndex)
#define VGAMiscWrite(p, data) VGAMiscWriteI((p)->scrnIndex, (data))
#define VGAMiscMask(p, data, mask) VGAMiscMaskI((p)->scrnIndex, (data), (mask))

CARD8 VGAStatus0ReadI(int scrnIndex);
CARD8 VGAStatus1ReadI(int scrnIndex);
#define VGAStatus0Read(p) VGAStatus0ReadI((p)->scrnIndex)
#define VGAStatus1Read(p) VGAStatus1ReadI((p)->scrnIndex)

CARD8 VGADACDataReadI(int scrnIndex);
void VGADACDataWriteI(int scrnIndex, CARD8 data);
void VGADACMaskWriteI(int scrnIndex, CARD8 data);
void VGADACReadAddressWriteI(int scrnIndex, CARD8 data);
void VGADACWriteAddressWriteI(int scrnIndex, CARD8 data);
#define VGADACDataRead(p) VGADACDataReadI((p)->scrnIndex)
#define VGADACDataWrite(p, data) VGADACDataWriteI((p)->scrnIndex, (data))
#define VGADACMaskWrite(p, data) VGADACMaskWriteI((p)->scrnIndex, (data))
#define VGADACReadAddressWrite(p, data) VGADACReadAddressWriteI((p)->scrnIndex, (data))
#define VGADACWriteAddressWrite(p, data) VGADACWriteAddressWriteI((p)->scrnIndex, (data))

CARD8 VGAARReadI(int scrnIndex, CARD8 index);
void VGAARWriteI(int scrnIndex, CARD8 index, CARD8 data);
#define VGAARRead(p, index) VGAARReadI((p)->scrnIndex, (index))
#define VGAARWrite(p, index, data) VGAARWriteI((p)->scrnIndex, (index), (data))

void VGADACAccessEnableI(int scrnIndex);
void VGADACAccessDisableI(int scrnIndex);
#define VGADACAccessEnable(p) VGADACAccessEnableI((p)->scrnIndex)
#define VGADACAccessDisable(p) VGADACAccessDisableI((p)->scrnIndex)

#endif /* HAVE_VIA_REGS_H */
